/******************************************************************************
 *
 * SYMPLiK CALLA
 * Copyright (C) 2010 Christopher Ho / SYMPLiK Tech. Co. Ltd.
 * All Rights Reserved, http://www.symplik.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * E-mail: christopher.ho@symplik.com
 *
 * ================================================
 *
 * $Archive: /TOOL/FLOWER/CALLA/src/symplik/flower/Constants.java $
 * $Author: Christopher Ho $
 * $Date: 6/08/10 1:56p $
 * $Revision: 3 $
******************************************************************************/

package symplik.flower;

/**
 * All constants used in CALLA framework
 * 
 * @author  $Author: Christopher Ho $
 * @version $Revision: 3 $
 */
public interface Constants {
  public static final String RCS_ID  = "$Header: /TOOL/FLOWER/CALLA/src/symplik/flower/Constants.java 3     6/08/10 1:56p Christopher Ho $";
  
  public static String       DISPLAY_MODE          = "symplik.flower.app.mode";
  public static String       DISPLAY_MODE_GUI      = "GUI";    
  public static String       DISPLAY_MODE_CONSOLE  = "CONSOLE";
  public static String       DISPLAY_MODE_SLIENT   = "SILENT";
  
  public static String       FLOWER_CONFIG         = "flower.config";  
  public static String       FLOWER_CONFIG_FILE    = "flower.properties";
  public static String       FLOWER_LOG_FILE       = "flower.log";
  public static String       FLOWER_LOG_LEVEL      = "flower.log.level";
  public static String       FLOWER_LOG_OUTPUT     = "flower.log.output";
  public static String       FLOWER_RESPONSES      = "flower.responses";
  public static String       FLOWER_RESPONSES_FILE = "responses.xml";

  public static String       FLOWER_LAST_QUESTION  = "flower.lastQuestion";
  
  public static int          LOG_DEBUG             = 0;
  public static int          LOG_INFO              = 1;  
  public static int          LOG_WARN              = 2;  
  public static int          LOG_ERROR             = 3;  
  
  public static String       LOG_OUTPUT_FILE       = "FILE";
  public static String       LOG_OUTPUT_SYSTEM_OUT = "CONSOLE";

  public static String       CLASS_DEFAULT_START   = "symplik.flower.DefaultQuestion";
  public static String       CLASS_FILE_BROWSER    = "symplik.flower.ConsoleFileBrowser";
  public static String       CLASS_DIR_BROWSER     = "symplik.flower.ConsoleDirBrowser";

  public static String       FILE_BROWSER_CURR_DIR = "flower.consleFileBroswer.currentDirectory";
  public static String       FILE_BROWSER_DIR      = "flower.consleFileBroswer.selectedDirectory";
  public static String       FILE_BROWSER_FILE     = "flower.consleFileBroswer.selectedtFile";
  // no sorting
  public static String       SORT_AS_IS            = "AS_IS";
  // case sensitve sorting
  public static String       SORT_BY_KEY           = "KEY";  
  public static String       SORT_BY_DESC          = "DESC";
  // case insensitve sorting
  public static String       SORT_BY_KEY_CI        = "KEY_CI";  
  public static String       SORT_BY_DESC_CI       = "DESC_CI";
  
}
