/******************************************************************************
 *
 * SYMPLiK CALLA
 * Copyright (C) 2010 Christopher Ho / SYMPLiK Tech. Co. Ltd.
 * All Rights Reserved, http://www.symplik.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * E-mail: christopher.ho@symplik.com
 *
 * ================================================
 *
 * $Archive: /TOOL/FLOWER/CALLA/src/symplik/flower/Executor.java $
 * $Author: Christopher Ho $
 * $Date: 6/02/10 12:34a $
 * $Revision: 3 $
******************************************************************************/

package symplik.flower;

/**
 * Executor to run Action class 
 * 
 * @author  $Author: Christopher Ho $
 * @version $Revision: 3 $
 */
public class Executor {
    public static final String RCS_ID =
        "$Header: /TOOL/FLOWER/CALLA/src/symplik/flower/Executor.java 3     6/02/10 12:34a Christopher Ho $";
    
    /**
     * @param Action subclass of Action
     */
    public static void execute(Action action) {
        boolean valid = action.enterAction();

        if (valid) {
            action.execute();
        }
    }
}
