package symplik.flower.sample;

//~--- non-JDK imports --------------------------------------------------------

import symplik.flower.Answer;
import symplik.flower.Choice;
import symplik.flower.Message;
import symplik.flower.Question;

//~--- JDK imports ------------------------------------------------------------

import java.util.ArrayList;

public class Question02 extends Question {
    @Override
    public String getQuestion() {
        return "Hello " + Answer.getInstance().getA("symplik.flower.sample.Question01") + "!\n\n"
               + "This is a multiple choice question.";
    }

    @Override
    public String getExplanation() {
        return "How old are you?";
    }

    @Override
    public ArrayList<Choice> choices() {
        ArrayList<Choice> al = new ArrayList<Choice>();

        al.add(new Choice("20-", "Younger than 20"));
        al.add(new Choice("30", "21-30"));
        al.add(new Choice("40", "31-40"));
        al.add(new Choice("50", "41-50"));
        al.add(new Choice("60", "51-60"));
        al.add(new Choice("70", "61-70"));
        al.add(new Choice("70+", "70 or higher"));

        return al;
    }

    @Override
    public boolean leaveQuestion() {
        String ans = Answer.getInstance().getA(this);

        if (ans.equals("20-")) {
            return false;
        } else {
            return true;
        }
    }

    @Override
    public Message leaveQuestionMsg(boolean flag) {
        if (flag) {
            return new Message(Message.INFO, "You are old enough to go to next question");
        } else {
            return new Message(Message.ERROR, "You are too young.");
        }
    }

    @Override
    public String lastAction() {
        return "symplik.flower.sample.Question01";
    }

    @Override
    public String nextAction() {
        return "symplik.flower.sample.Question03";
    }
}
