package symplik.flower.sample;

//~--- non-JDK imports --------------------------------------------------------

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.xpath.XPath;

import symplik.flower.Helper;
import symplik.flower.Question;

//~--- JDK imports ------------------------------------------------------------

import java.io.IOException;
import java.io.InputStream;

public class TestIntroduction extends Question {
    private String about       = null;
    private String instruction = null;

    @Override
    public boolean enterQuestion() {
        try {
            InputStream is      = this.getClass().getResourceAsStream("/symplik/flower/sample/Test.xml");
            SAXBuilder  builder = new SAXBuilder();
            Document    doc     = builder.build(is);
            XPath       xpath   = XPath.newInstance("//About");

            about       = ((Element) xpath.selectSingleNode(doc)).getValue();
            xpath       = XPath.newInstance("//Instruction");
            instruction = ((Element) xpath.selectSingleNode(doc)).getValue();
        } catch (JDOMException je) {
            Helper.log(LOG_ERROR, "Malformat XML file");
            System.exit(1);
        } catch (IOException ioe) {
            Helper.log(LOG_ERROR, "Unable to read question XML file");
            System.exit(1);
        }

        return true;
    }

    @Override
    public String getQuestion() {
        return about;
    }

    @Override
    public String getExplanation() {
        return instruction;
    }

    @Override
    public String getTitle() {
        return "Inernet Addition Test";
    }

    @Override
    public boolean isMultipleChoices() {
        return false;
    }

    @Override
    public boolean needAnswer() {
        return false;
    }

    @Override
    public String nextAction() {
        return "symplik.flower.sample.TestQuestion";
    }
}
